#version 430 core

const float levels = 15.0;

uniform samplerCube skybox;
uniform float brightness;

in vec3 TexCoords;
out vec4 color;

vec3 rgb2hsv(vec3 c)
{
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}
vec3 hsv2rgb(vec3 c)
{
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

void main()
{    
    // cel shading
    vec4 skyColorRGB = texture(skybox, TexCoords);
    //vec3 skyColorHSV = rgb2hsv(skyColorRGB.rgb);
    //float skyLevel = floor(skyColorHSV.z * levels);
	//skyColorHSV.z = (skyLevel / levels);

    //color = vec4(hsv2rgb(skyColorHSV), 1.0);
    color = brightness * skyColorRGB;
}